## iwyu 8.15

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.3)

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  message(STATUS "IWYU: out-of-tree configuration")
  set(IWYU_IN_TREE OFF)
else()
  message(STATUS "IWYU: in-tree configuration")
  set(IWYU_IN_TREE ON)
endif()

if (NOT IWYU_IN_TREE)
  cmake_policy(SET CMP0048 NEW)
  if (POLICY CMP0077)
    cmake_policy(SET CMP0077 NEW)
  endif()

  project(include-what-you-use)

  find_package(LLVM CONFIG REQUIRED)
  find_package(Clang CONFIG REQUIRED)

  list(APPEND CMAKE_MODULE_PATH ${LLVM_DIR})
  include(AddLLVM)
  include(HandleLLVMOptions)
endif()

message(STATUS "IWYU: configuring for LLVM ${LLVM_VERSION}...")

# The good default is given by the llvm toolchain installation itself, but still in
# case both static and shared libraries are available, allow to override that default.
option(IWYU_LINK_CLANG_DYLIB "Link against the clang dynamic library" ${CLANG_LINK_CLANG_DYLIB})

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

add_definitions(${LLVM_DEFINITIONS})
include_directories(
  ${LLVM_INCLUDE_DIRS}
  ${CLANG_INCLUDE_DIRS}
  )

set(LLVM_LINK_COMPONENTS
  Option
  Support
  X86AsmParser
  X86Desc
  X86Info
  )

add_llvm_executable(include-what-you-use
  iwyu.cc
  iwyu_ast_util.cc
  iwyu_cache.cc
  iwyu_driver.cc
  iwyu_getopt.cc
  iwyu_globals.cc
  iwyu_include_picker.cc
  iwyu_lexer_utils.cc
  iwyu_location_util.cc
  iwyu_output.cc
  iwyu_path_util.cc
  iwyu_preprocessor.cc
  iwyu_verrs.cc
  )

# Synthesize a clang-resource-headers target for out-of-tree builds (in-tree
# already has it available by default)
if (NOT IWYU_IN_TREE)
  # Use only major.minor.patch for the resource directory structure; some
  # platforms include suffix in LLVM_VERSION.
  set(llvm_ver ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})
  set(clang_headers_src "${LLVM_LIBRARY_DIR}/clang/${llvm_ver}/include")
  set(clang_headers_dst "${CMAKE_BINARY_DIR}/lib/clang/${llvm_ver}/include")

  file(GLOB_RECURSE in_files RELATIVE "${clang_headers_src}"
    "${clang_headers_src}/*")

  set(out_files)
  foreach (file ${in_files})
    set(src "${clang_headers_src}/${file}")
    set(dst "${clang_headers_dst}/${file}")

    add_custom_command(OUTPUT "${dst}"
      DEPENDS "${src}"
      COMMAND ${CMAKE_COMMAND} -E copy_if_different "${src}" "${dst}"
      COMMENT "Copying clang's ${file}...")
    list(APPEND out_files "${dst}")
  endforeach()

  add_custom_target(clang-resource-headers ALL DEPENDS ${out_files})
endif()

# Add a dependency on clang-resource-headers to ensure the builtin headers are
# available when IWYU is executed from the build dir.
add_dependencies(include-what-you-use clang-resource-headers)

if (MINGW)
  # Work around 'too many sections' error with MINGW/GCC
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wa,-mbig-obj")
endif()

if (MSVC)
  # Disable warnings for IWYU, and disable exceptions in MSVC's STL.
  add_definitions(
    -wd4722 # Suppress ''destructor'' : destructor never returns, potential memory leak
    -D_HAS_EXCEPTIONS=0
    )

  # Enable bigobj support and sane C++ exception semantics.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /EHsc")
endif()

# If only clang-cpp is available, we take that.
if (IWYU_LINK_CLANG_DYLIB)
  target_link_libraries(include-what-you-use PRIVATE clang-cpp)
else()
  target_link_libraries(include-what-you-use
    PRIVATE
    clangBasic
    clangLex
    clangAST
    clangSema
    clangFrontend
    clangDriver

    # Revision [1] in clang moved PCHContainerOperations from Frontend
    # to Serialization, but this broke builds that set
    # -DBUILD_SHARED_LIBS=on.  Revision [2] is a followup that works
    # around the issue by adding an explicit dependency on Serialization
    # wherever there was a dependency on Frontend.  Since we depend on
    # Frontend, we need an explicit dependency on Serialization too.
    # [1] https://llvm.org/viewvc/llvm-project?view=revision&revision=348907
    # [2] https://llvm.org/viewvc/llvm-project?view=revision&revision=348915
    clangSerialization
    )
endif()

# Platform dependencies.
if (WIN32)
  target_link_libraries(include-what-you-use
    PRIVATE
    shlwapi  # For PathMatchSpecA
    )
endif()

# Pick up Git revision so we can report it in version information.
include(FindGit)
if (GIT_FOUND AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE IWYU_GIT_REV
    OUTPUT_STRIP_TRAILING_WHITESPACE)
else()
  message(STATUS "Warning: IWYU Git version info not found, DO NOT release "
                 "from this build tree!")
endif()
add_definitions(-DIWYU_GIT_REV="${IWYU_GIT_REV}")

# Install programs
include(GNUInstallDirs)
install(TARGETS include-what-you-use RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(PROGRAMS fix_includes.py iwyu_tool.py DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install mapping files
file(GLOB MAPPING_FILES *.imp)
install(FILES ${MAPPING_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/include-what-you-use)

# Install man page on Unix-like systems
if (UNIX)
  install(FILES include-what-you-use.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
endif()

find_package(PythonInterp)
if(PYTHONINTERP_FOUND)
  enable_testing()
  add_test(NAME iwyu_tests
    COMMAND ${PYTHON_EXECUTABLE} run_iwyu_tests.py -- $<TARGET_FILE:include-what-you-use>
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
  add_test(NAME fix_includes_test
    COMMAND ${PYTHON_EXECUTABLE} fix_includes_test.py
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
  add_test(NAME iwyu_tool_test
    COMMAND ${PYTHON_EXECUTABLE} iwyu_tool_test.py
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

=== debian/changelog ===
iwyu (8.15-2) unstable; urgency=medium

  * Do not fail the testsuite on some arch (only a test is failing)
    (Closes: #981061)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 03 Feb 2021 09:15:49 +0100

iwyu (8.15-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository.

  [ Sylvestre Ledru ]
  * New upstream release 0.15
  * Move to clang-11 (Closes: #974814)
  * Add clang-{11,12} in the depends
  * Upstream updated their versioning on github. it was called
    clang_8.0, it is now 0.14; Called this version 8.14 as we cannot
    go back to 0.14. Update watch
  * Update watch file format version to 4.

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 26 Nov 2020 15:39:04 +0100

=== debian/control ===
Source: iwyu
Section: devel
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper-compat (= 12), cmake, clang-11, libclang-11-dev,
 llvm-11-dev, help2man, libncurses5-dev, zlib1g-dev, chrpath
Build-Conflicts: llvm-5.0-dev, llvm-6.0-dev
Standards-Version: 4.2.1
Homepage: https://include-what-you-use.org/
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/iwyu.git
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/iwyu

Package: iwyu
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 clang | clang-4.0 | clang-5.0 | clang-6.0 | clang-7 | clang-8 | clang-9 | clang-10 | clang-11 | clang-12,
 python3
Description: Analyze #includes in C and C++ source files
 "Include what you use" means this: for every symbol (type, function variable,
 or macro) that you use in foo.cc, either foo.cc or foo.h should #include a .h
 file that exports the declaration of that symbol. The include-what-you-use
 tool is a program that can be built with the clang libraries in order to
 analyze #includes of source files to find include-what-you-use violations,
 and suggest fixes for them.
 .
 The main goal of include-what-you-use is to remove superfluous #includes.
 It does this both by figuring out what #includes are not actually needed for
 this file (for both .cc and .h files), and replacing #includes with
 forward-declares when possible.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

TARGET_BUILD=iwyu-build
VERSION=$(shell dpkg-parsechangelog |grep "^Version:"|sed -e "s|Version: \(.*\)|\1|")
include /usr/share/dpkg/architecture.mk
ADDITIONAL_CXX_FLAGS=""

ifneq (,$(filter $(DEB_BUILD_ARCH),mips64el))
	ADDITIONAL_CXX_FLAGS += -mxgot
endif

ifneq (,$(filter $(DEB_HOST_ARCH), armel))
	export DEB_LDFLAGS_MAINT_APPEND = -latomic
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=$(TARGET_BUILD)


override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-11/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-11/


override_dh_auto_build:
	dh_auto_build
	help2man --no-info --version-string "$(VERSION)" -n "Analyze #includes in C and C++ source files" $(TARGET_BUILD)/bin/include-what-you-use > $(TARGET_BUILD)/include-what-you-use.1
	cd $(TARGET_BUILD) && ln -s include-what-you-use.1 iwyu.1 && \
	cp ../fix_includes.py fix_include
	chrpath -d $(TARGET_BUILD)/bin/include-what-you-use


override_dh_auto_install:
	dh_auto_install
	cd debian/iwyu/usr/bin; \
		rm -f fix_includes.py; \
		mv iwyu_tool.py iwyu_tool

override_dh_auto_test:
# Do not fail the build if a test is failing.
# It isn't tested upstream besides i386 & amd64
	dh_auto_test || true

override_dh_auto_clean:
	rm -rf $(TARGET_BUILD)

## iwyu 8.17

=== debian/changelog ===
iwyu (8.17-1) unstable; urgency=medium

  * New upstream release
  * Update llvm/clang from 12 to 13

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 09 Dec 2021 13:25:46 +0100

iwyu (8.16-1) unstable; urgency=medium

  * New upstream release
  * Update llvm/clang from 11 to 12

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 20 Jun 2021 18:51:18 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper-compat (= 12), cmake, clang-11, libclang-11-dev,
- llvm-11-dev, help2man, libncurses5-dev, zlib1g-dev, chrpath
+Build-Depends: debhelper-compat (= 12), cmake, clang-13, libclang-13-dev,
+ llvm-13-dev, help2man, libncurses5-dev, zlib1g-dev, chrpath
 Build-Conflicts: llvm-5.0-dev, llvm-6.0-dev
 Standards-Version: 4.2.1
 Homepage: https://include-what-you-use.org/
@@ -14,7 +14,7 @@
 Package: iwyu
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
- clang | clang-4.0 | clang-5.0 | clang-6.0 | clang-7 | clang-8 | clang-9 | clang-10 | clang-11 | clang-12,
+ clang | clang-4.0 | clang-5.0 | clang-6.0 | clang-7 | clang-8 | clang-9 | clang-10 | clang-11 | clang-12 | clang-13,
  python3
 Description: Analyze #includes in C and C++ source files
  "Include what you use" means this: for every symbol (type, function variable,

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-11/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-11/
+	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-12/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-12/
 
 
 override_dh_auto_build:

## iwyu 8.18

=== CMakeLists.txt ===
--- 
+++ 
@@ -38,12 +38,39 @@
   ${CLANG_INCLUDE_DIRS}
   )
 
+# Synthesize a clang-resource-headers target for out-of-tree builds (in-tree
+# already has it available by default)
+if (NOT IWYU_IN_TREE)
+  # Use only major.minor.patch for the resource directory structure; some
+  # platforms include suffix in LLVM_VERSION.
+  set(llvm_ver ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})
+  set(clang_headers_src "${LLVM_LIBRARY_DIR}/clang/${llvm_ver}/include")
+  set(clang_headers_dst "${CMAKE_BINARY_DIR}/lib/clang/${llvm_ver}/include")
+
+  file(GLOB_RECURSE in_files RELATIVE "${clang_headers_src}"
+    "${clang_headers_src}/*")
+
+  set(out_files)
+  foreach (file ${in_files})
+    set(src "${clang_headers_src}/${file}")
+    set(dst "${clang_headers_dst}/${file}")
+
+    add_custom_command(OUTPUT "${dst}"
+      DEPENDS "${src}"
+      COMMAND ${CMAKE_COMMAND} -E copy_if_different "${src}" "${dst}"
+      COMMENT "Copying clang's ${file}...")
+    list(APPEND out_files "${dst}")
+  endforeach()
+
+  add_custom_target(clang-resource-headers ALL DEPENDS ${out_files})
+endif()
+
 set(LLVM_LINK_COMPONENTS
   Option
   Support
-  X86AsmParser
-  X86Desc
-  X86Info
+  AllTargetsAsmParsers
+  AllTargetsDescs
+  AllTargetsInfos
   )
 
 add_llvm_executable(include-what-you-use
@@ -62,36 +89,14 @@
   iwyu_verrs.cc
   )
 
-# Synthesize a clang-resource-headers target for out-of-tree builds (in-tree
-# already has it available by default)
-if (NOT IWYU_IN_TREE)
-  # Use only major.minor.patch for the resource directory structure; some
-  # platforms include suffix in LLVM_VERSION.
-  set(llvm_ver ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})
-  set(clang_headers_src "${LLVM_LIBRARY_DIR}/clang/${llvm_ver}/include")
-  set(clang_headers_dst "${CMAKE_BINARY_DIR}/lib/clang/${llvm_ver}/include")
-
-  file(GLOB_RECURSE in_files RELATIVE "${clang_headers_src}"
-    "${clang_headers_src}/*")
-
-  set(out_files)
-  foreach (file ${in_files})
-    set(src "${clang_headers_src}/${file}")
-    set(dst "${clang_headers_dst}/${file}")
-
-    add_custom_command(OUTPUT "${dst}"
-      DEPENDS "${src}"
-      COMMAND ${CMAKE_COMMAND} -E copy_if_different "${src}" "${dst}"
-      COMMENT "Copying clang's ${file}...")
-    list(APPEND out_files "${dst}")
-  endforeach()
-
-  add_custom_target(clang-resource-headers ALL DEPENDS ${out_files})
-endif()
-
 # Add a dependency on clang-resource-headers to ensure the builtin headers are
 # available when IWYU is executed from the build dir.
 add_dependencies(include-what-you-use clang-resource-headers)
+
+# LLVM requires C++14, so follow suit.
+set_property(TARGET include-what-you-use PROPERTY CXX_STANDARD_REQUIRED ON)
+set_property(TARGET include-what-you-use PROPERTY CXX_STANDARD 14)
+set_property(TARGET include-what-you-use PROPERTY CXX_EXTENSIONS OFF)
 
 if (MINGW)
   # Work around 'too many sections' error with MINGW/GCC
@@ -105,11 +110,11 @@
     -D_HAS_EXCEPTIONS=0
     )
 
-  # Enable bigobj support and sane C++ exception semantics.
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /EHsc")
-endif()
-
-# If only clang-cpp is available, we take that.
+  # Enable bigobj support
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
+endif()
+
+# Link dynamically or statically depending on user preference.
 if (IWYU_LINK_CLANG_DYLIB)
   target_link_libraries(include-what-you-use PRIVATE clang-cpp)
 else()
@@ -172,9 +177,23 @@
 find_package(PythonInterp)
 if(PYTHONINTERP_FOUND)
   enable_testing()
-  add_test(NAME iwyu_tests
-    COMMAND ${PYTHON_EXECUTABLE} run_iwyu_tests.py -- $<TARGET_FILE:include-what-you-use>
-    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
+
+  function(ADD_IWYU_TEST NAME FILE)
+    add_test(NAME ${NAME}
+      COMMAND ${PYTHON_EXECUTABLE} run_iwyu_tests.py --run-test-file=${FILE} -- $<TARGET_FILE:include-what-you-use>
+      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
+  endfunction()
+
+  execute_process(
+    COMMAND ${PYTHON_EXECUTABLE} run_iwyu_tests.py --list-test-files
+    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+    OUTPUT_VARIABLE TEST_NAMES_AND_FILES)
+  string(REPLACE "\n" ";" TEST_NAMES_LIST ${TEST_NAMES_AND_FILES})
+  foreach (TEST_NAME_AND_FILE IN ITEMS ${TEST_NAMES_LIST})
+    string(REPLACE ":" ";" TEST_NAME_AND_FILE ${TEST_NAME_AND_FILE})
+    ADD_IWYU_TEST(${TEST_NAME_AND_FILE})
+  endforeach()
+
   add_test(NAME fix_includes_test
     COMMAND ${PYTHON_EXECUTABLE} fix_includes_test.py
     WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== debian/changelog ===
iwyu (8.18-2) unstable; urgency=medium

  * Build using release.
    Thanks to Steven Trabert
    (Closes: #1016949)
  * Force the usage of clang-14 (Closes: #1014003, #1010495, #1003487)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 10 Aug 2022 22:36:00 +0200

iwyu (8.18-1) unstable; urgency=medium

  * New upstream release
  * Update llvm/clang from 13 to 14
  * Bump debhelper from old 12 to 13.

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 08 Apr 2022 13:05:36 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper-compat (= 12), cmake, clang-13, libclang-13-dev,
- llvm-13-dev, help2man, libncurses5-dev, zlib1g-dev, chrpath
+Build-Depends: debhelper-compat (= 13), cmake, clang-14, libclang-14-dev,
+ llvm-14-dev, help2man, libncurses5-dev, zlib1g-dev, chrpath
 Build-Conflicts: llvm-5.0-dev, llvm-6.0-dev
 Standards-Version: 4.2.1
 Homepage: https://include-what-you-use.org/
@@ -14,7 +14,7 @@
 Package: iwyu
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
- clang | clang-4.0 | clang-5.0 | clang-6.0 | clang-7 | clang-8 | clang-9 | clang-10 | clang-11 | clang-12 | clang-13,
+ clang, clang-14,
  python3
 Description: Analyze #includes in C and C++ source files
  "Include what you use" means this: for every symbol (type, function variable,

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-12/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-12/
+	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-14/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-14/
 
 
 override_dh_auto_build:

## iwyu 8.21

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20.0)

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  set(iwyu_standalone_build ON)
  message(STATUS "IWYU: standalone build")
else()
  set(iwyu_standalone_build OFF)
  message(STATUS "IWYU: build as part of LLVM")
endif()

if (iwyu_standalone_build)
  cmake_policy(SET CMP0048 NEW)
  if (POLICY CMP0077)
    cmake_policy(SET CMP0077 NEW)
  endif()

  project(include-what-you-use)

  find_package(LLVM CONFIG REQUIRED)
  find_package(Clang CONFIG REQUIRED)

  list(APPEND CMAKE_MODULE_PATH ${LLVM_DIR})
  include(AddLLVM)
  include(HandleLLVMOptions)

  set(iwyu_llvm_dir ${LLVM_DIR})
  set(iwyu_include_dirs
    ${LLVM_INCLUDE_DIRS}
    ${CLANG_INCLUDE_DIRS}
  )
else()
  set(iwyu_llvm_dir ${CMAKE_SOURCE_DIR})
  set(iwyu_include_dirs
    ${LLVM_SOURCE_DIR}/include
    ${LLVM_EXTERNAL_CLANG_SOURCE_DIR}/include
    ${LLVM_BINARY_DIR}/include
    ${LLVM_BINARY_DIR}/tools/clang/include
  )
endif()

message(STATUS
  "IWYU: configuring for LLVM ${LLVM_VERSION} from ${iwyu_llvm_dir}")

# The good default is given by the llvm toolchain installation itself, but still
# in case both static and shared libraries are available, allow to override that
# default.
option(IWYU_LINK_CLANG_DYLIB
  "Link against the clang dynamic library"
  ${CLANG_LINK_CLANG_DYLIB}
)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

# Synthesize clang-resource-headers target if necessary.
if (NOT TARGET clang-resource-headers)
  # Use only LLVM_VERSION_MAJOR for the resource directory structure; some
  # platforms include suffix in LLVM_VERSION.
  set(clang_headers_src "${LLVM_LIBRARY_DIR}/clang/${LLVM_VERSION_MAJOR}/include")
  set(clang_headers_dst "${CMAKE_BINARY_DIR}/lib/clang/${LLVM_VERSION_MAJOR}/include")

  file(GLOB_RECURSE in_files RELATIVE "${clang_headers_src}"
    "${clang_headers_src}/*"
  )

  set(out_files)
  foreach (file ${in_files})
    set(src "${clang_headers_src}/${file}")
    set(dst "${clang_headers_dst}/${file}")

    add_custom_command(OUTPUT "${dst}"
      DEPENDS "${src}"
      COMMAND ${CMAKE_COMMAND} -E copy_if_different "${src}" "${dst}"
      COMMENT "Copying ${src}..."
    )
    list(APPEND out_files "${dst}")
  endforeach()

  add_custom_target(clang-resource-headers ALL DEPENDS ${out_files})
endif()

# Pick up Git revision so we can report it in version information.
include(FindGit)
if (GIT_FOUND AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE iwyu_git_rev
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
else()
  message(WARNING "IWYU Git version not found, DO NOT release from this tree!")
endif()

set(LLVM_LINK_COMPONENTS
  Option
  Support
  AllTargetsAsmParsers
  AllTargetsDescs
  AllTargetsInfos
)

add_llvm_executable(include-what-you-use
  iwyu.cc
  iwyu_ast_util.cc
  iwyu_cache.cc
  iwyu_driver.cc
  iwyu_getopt.cc
  iwyu_globals.cc
  iwyu_include_picker.cc
  iwyu_lexer_utils.cc
  iwyu_location_util.cc
  iwyu_output.cc
  iwyu_path_util.cc
  iwyu_preprocessor.cc
  iwyu_regex.cc
  iwyu_verrs.cc
)

# Add a dependency on clang-resource-headers to ensure the builtin headers are
# available when IWYU is executed from the build dir.
add_dependencies(include-what-you-use clang-resource-headers)

# LLVM requires C++17, so follow suit.
set_target_properties(include-what-you-use PROPERTIES
  CXX_STANDARD_REQUIRED ON
  CXX_STANDARD 17
  CXX_EXTENSIONS OFF
)

target_compile_definitions(include-what-you-use PRIVATE
  ${LLVM_DEFINITIONS}
  IWYU_GIT_REV="${iwyu_git_rev}"
)
target_include_directories(include-what-you-use PRIVATE
  ${iwyu_include_dirs}
)

if (MINGW)
  target_compile_options(include-what-you-use PRIVATE
    # Work around 'too many sections' error with MINGW/GCC.
    -Wa,-mbig-obj
  )
endif()

if (MSVC)
  target_compile_options(include-what-you-use PRIVATE
    # Suppress ''destructor'' : destructor never returns, potential memory leak.
    /wd4722
    # Disable exceptions in MSVC STL.
    /D_HAS_EXCEPTIONS=0
    # Suppress C1128: number of sections exceeded object file format limit.
    /bigobj
  )
endif()

# Link dynamically or statically depending on user preference.
if (IWYU_LINK_CLANG_DYLIB)
  target_link_libraries(include-what-you-use PRIVATE clang-cpp)
else()
  target_link_libraries(include-what-you-use PRIVATE
    clangBasic
    clangLex
    clangAST
    clangSema
    clangFrontend
    clangDriver

    # Revision [1] in clang moved PCHContainerOperations from Frontend
    # to Serialization, but this broke builds that set
    # -DBUILD_SHARED_LIBS=on.  Revision [2] is a followup that works
    # around the issue by adding an explicit dependency on Serialization
    # wherever there was a dependency on Frontend.  Since we depend on
    # Frontend, we need an explicit dependency on Serialization too.
    # [1] https://llvm.org/viewvc/llvm-project?view=revision&revision=348907
    # [2] https://llvm.org/viewvc/llvm-project?view=revision&revision=348915
    clangSerialization

    clangToolingInclusionsStdlib
  )
endif()

# Add platform-specific link dependencies.
if (WIN32)
  target_link_libraries(include-what-you-use PRIVATE
    shlwapi  # for PathMatchSpecA
  )
endif()

# Install programs.
include(GNUInstallDirs)
install(TARGETS
  include-what-you-use
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)
install(PROGRAMS
  fix_includes.py
  iwyu_tool.py
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

# Install mapping files.
file(GLOB mapping_files *.imp)
install(FILES
  ${mapping_files}
  DESTINATION ${CMAKE_INSTALL_DATADIR}/include-what-you-use
)

# Install man page on Unix-like systems.
if (UNIX)
  install(FILES
    include-what-you-use.1
    DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
  )
endif()

find_package(Python3 COMPONENTS Interpreter)
if (Python3_Interpreter_FOUND)
  # Map the various IWYU test scripts to CTest tests.
  enable_testing()

  function(iwyu_add_test name file)
    add_test(NAME ${name}
      COMMAND ${Python3_EXECUTABLE} run_iwyu_tests.py --run-test-file=${file}
      -- $<TARGET_FILE:include-what-you-use>
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )
    set_tests_properties(${name} PROPERTIES SKIP_RETURN_CODE 77)
  endfunction()

  execute_process(
    COMMAND ${Python3_EXECUTABLE} run_iwyu_tests.py --list-test-files
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE test_names_and_files
  )
  string(REPLACE "\n" ";" test_names_list ${test_names_and_files})
  foreach (test_name_and_file IN ITEMS ${test_names_list})
    string(REPLACE ":" ";" test_name_and_file ${test_name_and_file})
    iwyu_add_test(${test_name_and_file})
  endforeach()

  add_test(NAME fix_includes_test
    COMMAND ${Python3_EXECUTABLE} fix_includes_test.py
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
  add_test(NAME iwyu_tool_test
    COMMAND ${Python3_EXECUTABLE} iwyu_tool_test.py
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
endif()

=== debian/changelog ===
iwyu (8.21-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:00:26 +1100

iwyu (8.21-1build1) noble; urgency=medium

  * No-change rebuild against libllvm17t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 07:09:50 +0000

iwyu (8.21-1) unstable; urgency=low

    Remove patches GlobalSourceManager.patch, PrintableStmt.patch that are missing from debian/patches/series.
  * new upstream release
  * Remove old Build-Conflicts
  * upgrade to llvm/clang 17

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 06 Jan 2024 20:21:18 +0100

iwyu (8.19-1) unstable; urgency=medium

  * New upstream release
  * Update llvm/clang from 14 to 15

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 04 Nov 2022 22:58:13 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: iwyu
 Section: devel
 Priority: optional
-Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake, clang-14, libclang-14-dev,
- llvm-14-dev, help2man, libncurses5-dev, zlib1g-dev, chrpath
-Build-Conflicts: llvm-5.0-dev, llvm-6.0-dev
+Build-Depends: debhelper-compat (= 13), cmake, clang-17, libclang-17-dev,
+ llvm-17-dev, help2man, libncurses5-dev, zlib1g-dev, chrpath
 Standards-Version: 4.2.1
 Homepage: https://include-what-you-use.org/
 Vcs-Git: https://salsa.debian.org/pkg-llvm-team/iwyu.git
@@ -14,7 +14,7 @@
 Package: iwyu
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
- clang, clang-14,
+ clang, clang-17,
  python3
 Description: Analyze #includes in C and C++ source files
  "Include what you use" means this: for every symbol (type, function variable,

=== debian/rules ===
--- 
+++ 
@@ -22,13 +22,13 @@
 
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-14/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-14/
+	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-17/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-17/ -DCMAKE_BUILD_WITH_INSTALL_RPATH=TRUE
 
 
 override_dh_auto_build:
 	dh_auto_build
 	help2man --no-info --version-string "$(VERSION)" -n "Analyze #includes in C and C++ source files" $(TARGET_BUILD)/bin/include-what-you-use > $(TARGET_BUILD)/include-what-you-use.1
-	cd $(TARGET_BUILD) && ln -s include-what-you-use.1 iwyu.1 && \
+	cd $(TARGET_BUILD) && rm -f iwyu.1 && ln -s include-what-you-use.1 iwyu.1 && \
 	cp ../fix_includes.py fix_include
 	chrpath -d $(TARGET_BUILD)/bin/include-what-you-use

=== debian/watch ===
version=4
opts=uversionmangle=s/^/8./ https://github.com/include-what-you-use/include-what-you-use/tags .*/0.(.*)\.tar\.gz

## iwyu 8.22

=== debian/changelog ===
iwyu (8.22-1) unstable; urgency=medium

  * New upstream release
  * Update llvm/clang from 17 to 18
  * Remove empty debian/patches/series.
  * Fix build-depends-on-obsolete-package Build-Depends:
    libncurses5-dev => libncurses-dev

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 23 Apr 2024 21:54:22 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: iwyu
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
+Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake, clang-17, libclang-17-dev,
- llvm-17-dev, help2man, libncurses5-dev, zlib1g-dev, chrpath
+Build-Depends: debhelper-compat (= 13), cmake, clang-18, libclang-18-dev,
+ llvm-18-dev, help2man, libncurses-dev, zlib1g-dev, chrpath
 Standards-Version: 4.2.1
 Homepage: https://include-what-you-use.org/
 Vcs-Git: https://salsa.debian.org/pkg-llvm-team/iwyu.git
@@ -14,7 +13,7 @@
 Package: iwyu
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
- clang, clang-17,
+ clang, clang-18,
  python3
 Description: Analyze #includes in C and C++ source files
  "Include what you use" means this: for every symbol (type, function variable,

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-17/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-17/ -DCMAKE_BUILD_WITH_INSTALL_RPATH=TRUE
+	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-18/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-18/ -DCMAKE_BUILD_WITH_INSTALL_RPATH=TRUE
 
 
 override_dh_auto_build:

## iwyu 8.23

=== debian/changelog ===
iwyu (8.23-1) unstable; urgency=medium

  * New upstream release
  * Update of standard version to 4.7
  * Update llvm/clang from 18 to 19

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 14 Nov 2024 13:53:02 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake, clang-18, libclang-18-dev,
- llvm-18-dev, help2man, libncurses-dev, zlib1g-dev, chrpath
-Standards-Version: 4.2.1
+Build-Depends: debhelper-compat (= 13), cmake, clang-19, libclang-19-dev,
+ llvm-19-dev, help2man, libncurses-dev, zlib1g-dev, chrpath
+Standards-Version: 4.7.0
 Homepage: https://include-what-you-use.org/
 Vcs-Git: https://salsa.debian.org/pkg-llvm-team/iwyu.git
 Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/iwyu
@@ -13,7 +13,7 @@
 Package: iwyu
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
- clang, clang-18,
+ clang, clang-19,
  python3
 Description: Analyze #includes in C and C++ source files
  "Include what you use" means this: for every symbol (type, function variable,

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-18/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-18/ -DCMAKE_BUILD_WITH_INSTALL_RPATH=TRUE
+	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-19/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-19/ -DCMAKE_BUILD_WITH_INSTALL_RPATH=TRUE
 
 
 override_dh_auto_build:
